## ssh-tpm-agent 0.8.0

=== Makefile ===
PREFIX := /usr/local
BINDIR := $(PREFIX)/bin
LIBDIR := $(PREFIX)/lib
SHRDIR := $(PREFIX)/share
MANDIR := $(PREFIX)/share/man
BINS = $(filter-out %_test.go,$(notdir $(wildcard cmd/*)))
TAG = $(shell git describe --abbrev=0 --tags)
VERSION = $(shell git describe --abbrev=7 | sed 's/-/./g;s/^v//;')

MANPAGES = \
	man/ssh-tpm-hostkeys.1 \
	man/ssh-tpm-agent.1 \
	man/ssh-tpm-keygen.1 \
	man/ssh-tpm-add.1

all: man build
build: $(BINS)
man: $(MANPAGES)

.PHONY: $(addprefix bin/,$(BINS))
$(addprefix bin/,$(BINS)):
	go build -buildmode=pie -trimpath -o $@ ./cmd/$(@F)

# TODO: Needs to be better written
$(BINS): $(addprefix bin/,$(BINS))


.PHONY: install
install: $(BINS)
	@for bin in $(BINS); do \
		install -Dm755 "bin/$$bin" -t '$(DESTDIR)$(BINDIR)'; \
	done;
	for manfile in $(MANPAGES); do \
		install -Dm644 "$$manfile" -t '$(DESTDIR)$(MANDIR)/man'"$${manfile##*.}"; \
	done;
	@install -dm755 $(DESTDIR)$(LIBDIR)/systemd/system
	@install -dm755 $(DESTDIR)$(LIBDIR)/systemd/user
	@DESTDIR=$(DESTDIR) PREFIX=$(PREFIX) bin/ssh-tpm-hostkeys --install-system-units 
	@TEMPLATE_BINARY=$(BINDIR)/ssh-tpm-agent DESTDIR=$(DESTDIR) PREFIX=$(PREFIX) bin/ssh-tpm-agent --install-user-units --install-system

.PHONY: lint
lint:
	go vet ./...
	staticcheck ./...

.PHONY: test
test:
	go test -v ./...

.PHONY: clean
clean:
	rm -rf bin/
	rm -f $(MANPAGES)

sign-release:
	gh release download $(TAG)
	gpg --sign ssh-tpm-agent-$(TAG)-linux-amd64.tar.gz
	gpg --sign ssh-tpm-agent-$(TAG)-linux-arm64.tar.gz
	gpg --sign ssh-tpm-agent-$(TAG)-linux-arm.tar.gz
	bash -c "gh release upload $(TAG) ssh-tpm-agent-$(TAG)*.gpg"

man/%: man/%.adoc Makefile
	asciidoctor -b manpage -amansource="ssh-tpm-agent $(VERSION)" -amanversion="$(VERSION)" $<

=== debian/changelog ===
ssh-tpm-agent (0.8.0-2) unstable; urgency=medium

  * Drop Priority: optional
  * Standards-Version: 4.7.3
  * Bump debian/* copyright years
  * Drop newgateway pipeline

 -- Simon Josefsson <simon@josefsson.org>  Fri, 13 Feb 2026 11:12:12 +0100

ssh-tpm-agent (0.8.0-1) unstable; urgency=medium

  * Initial release (Closes: 1082814)

 -- Simon Josefsson <simon@josefsson.org>  Thu, 04 Dec 2025 22:55:28 +0100

=== debian/control ===
Source: ssh-tpm-agent
Section: golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 asciidoctor <!nodoc>,
 golang-any,
 golang-github-awnumar-memcall-dev,
 golang-github-coreos-go-oidc-v3-dev,
 golang-github-foxboron-go-tpm-keyfiles-dev,
 golang-github-google-go-tpm-dev,
 golang-github-landlock-lsm-go-landlock-dev,
 golang-github-pkg-browser-dev,
 golang-github-segmentio-ksuid-dev,
 golang-github-sigstore-sigstore-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-oauth2-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-term-dev,
 golang-golang-x-text-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/ssh-tpm-agent
Vcs-Git: https://salsa.debian.org/go-team/packages/ssh-tpm-agent.git
Homepage: https://github.com/foxboron/ssh-tpm-agent
XS-Go-Import-Path: github.com/foxboron/ssh-tpm-agent

Package: ssh-tpm-agent
Section: admin
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: ssh-agent for TPMs (program)
 SSH agent for TPM
 .
 ssh-tpm-agent is a ssh-agent compatible agent that allows keys to be
 created by the Trusted Platform Module (TPM) for authentication towards
 ssh servers.
 .
 TPM sealed keys are private keys created inside the Trusted Platform
 Module (TPM) and sealed in .tpm suffixed files. They are bound to the
 hardware they are produced on and can't be transferred to other
 machines.
 .
 This allows you to utilize a native client instead of having to side
 load existing PKCS11 libraries into the ssh-agent and/or ssh client.
 .
 The project uses TPM 2.0 Key Files
 (https://www.hansenpartnership.com/draft-bottomley-tpm2-keys.html)
 implemented through the go-tpm-keyfiles (https://github.com/Foxboron/go-tpm-
 keyfiles) project.
 .
 Features
 .
  * A working ssh-agent.
  * Create shielded ssh keys on the TPM.
  * Creation of remotely wrapped SSH keys for import.
  * PIN support, dictionary attack protection from the TPM allows you to
    use low entropy PINs instead of passphrases.
  * TPM session encryption.
  * Proxy support towards other ssh-agent servers for fallbacks.
 .
 This package contains the command-line tools.

Package: golang-github-foxboron-ssh-tpm-agent-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-awnumar-memcall-dev,
 golang-github-coreos-go-oidc-v3-dev,
 golang-github-foxboron-go-tpm-keyfiles-dev,
 golang-github-google-go-tpm-dev,
 golang-github-landlock-lsm-go-landlock-dev,
 golang-github-pkg-browser-dev,
 golang-github-segmentio-ksuid-dev,
 golang-github-sigstore-sigstore-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-oauth2-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-term-dev,
 golang-golang-x-text-dev,
 ${misc:Depends},
Description: Go ssh-agent for TPMs (library)
 ssh-tpm-agent is a ssh-agent compatible agent that allows keys to be
 created by the Trusted Platform Module (TPM) for authentication towards
 ssh servers.
 .
 This package contains the development library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk # DEB_VERSION

export DH_GOLANG_INSTALL_EXTRA := contrib/services contrib/sshd

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_build: # debian/README.source
	cp -vr $(CURDIR)/debian/local/ssh-tpm-ca-authority/ _build/src/github.com/foxboron/

M = $(CURDIR)/debian/tmp/usr/share/man/man1
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
execute_before_dh_installman-arch:
	$(MAKE) man VERSION=$(DEB_VERSION)
	mkdir -pv $(M)
	mv -v man/*.1 $(M)/
endif

execute_before_dh_auto_test:
# src/github.com/foxboron/ssh-tpm-agent/agent/agent_test.go:19:2: cannot find package "github.com/google/go-tpm/tpm2/transport/simulator" in any of:
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/agent/agent_test.go
# 2025/11/26 11:56:42 GetFixedSim disabled by Debian
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/cmd/scripts_test.go
# src/github.com/foxboron/ssh-tpm-agent/cmd/ssh-tpm-agent/main_test.go:21:2: cannot find package "github.com/google/go-tpm/tpm2/transport/simulator" in any of:
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/cmd/ssh-tpm-agent/main_test.go
# src/github.com/foxboron/ssh-tpm-agent/key/hierarchy_keys_test.go:14:2: cannot find package "github.com/google/go-tpm/tpm2/transport/simulator" in any of:
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/key/hierarchy_keys_test.go
# keyring_test.go:37: err: no such file or directory
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/internal/keyring/keyring_test.go
# threadkeyring_test.go:45: err: no such file or directory
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/internal/keyring/threadkeyring_test.go
# I: golang-github-foxboron-ssh-tpm-agent-dev: package-contains-documentation-outside-usr-share-doc
	rm -fv $(CURDIR)/_build/src/github.com/foxboron/ssh-tpm-agent/testdata/script/*.txt

=== debian/watch ===
Version: 5
Template: Github
Owner: foxboron
Project: ssh-tpm-agent
